
extern double get_max_norm_inf_speed(configPt q_i, configPt q_f, double tf,int index_dof);
extern double get_max_norm_inf_acceleration(configPt q_i, configPt q_f, double tf,int index_dof);
extern double get_max_norm_inf_jerk(configPt q_i, configPt q_f, double tf,int index_dof);
extern double get_tf_opt_speed(p3d_rob *robotPt, configPt q_i, configPt q_f);
extern double get_tf_opt_acceleration(p3d_rob *robotPt, configPt q_i, configPt q_f);
extern double get_tf_opt_jerk(p3d_rob *robotPt, configPt q_i, configPt q_f);
extern double get_tf_opt(p3d_rob *robotPt, configPt q_i, configPt q_f);
extern p3d_hermite_data *p3d_alloc_spec_hermite_localpath (p3d_rob *robotPt, configPt q_i, configPt q_f);
extern p3d_localpath *p3d_alloc_hermite_localpath(p3d_rob *robotPt, configPt q_i, configPt q_f, int lp_id,int is_valid);
extern double p3d_hermite_dist(p3d_rob *robotPt, p3d_localpath *localpathPt);
extern configPt p3d_hermite_config_at_param(p3d_rob *robotPt, p3d_localpath *localpathPt, double param);
extern p3d_localpath *p3d_extract_hermite(p3d_rob *robotPt, p3d_localpath *localpathPt, double t1, double t2);
extern lm_hermite_str *lm_get_hermite_lm_param(p3d_rob* robotPt);
extern lm_hermite_str *lm_create_hermite(p3d_rob *robotPt, double *dtab, int *itab);
extern int p3d_create_hermite_local_method(double *dtab, int *itab);
extern void p3d_destroy_hermite_data(p3d_rob* robotPt, p3d_hermite_data* hermite_dataPt);
extern void p3d_hermite_destroy(p3d_rob* robotPt, p3d_localpath* localpathPt);
extern p3d_localpath *p3d_copy_hermite_localpath(p3d_rob* robotPt, p3d_localpath* localpathPt);
extern double p3d_hermite_cost(p3d_rob *robotPt, p3d_localpath *localpathPt);
extern p3d_localpath *p3d_simplify_hermite(p3d_rob *robotPt, p3d_localpath *localpathPt, int *need_colcheck);
extern int p3d_write_hermite(FILE *file, p3d_rob* robotPt, p3d_localpath* localpathPt);
extern double p3d_hermite_stay_within_dist(p3d_rob* robotPt, p3d_localpath* localpathPt, double parameter, whichway dir, double *distances);
extern p3d_localpath *p3d_hermite_localplanner (p3d_rob *robotPt, configPt qi, configPt qf, int * ikSol);
extern void print_hermite_data(p3d_rob * robotPt,p3d_hermite_data* hermite_data);
extern void p3d_alex_debug(p3d_rob * robotPt);
